:start
@echo off
REM ==============================================================================
REM ==============================================================================
REM
REM ------------------------------------------------------------------------------
REM  * * * This is necessary startup stuff, skip this. * * *
REM   * * *   Go a page down to the config section.  * * *
REM ------------------------------------------------------------------------------
REM
cls
set script_title=Mapmaker Batch Install v02
set install_mapmaker=INSTALL_urt4_mapmaker_v02.bat
set current_zpak=zpak000.pk3
title %script_title%
REM We'll skip the initial config if the q3ut4 path has been specified.
if (%install_mapmaker_completed%)==(true) (
exit
)
if ("%1")==("override") (
set q3ut4_path=%CD%
goto ready
)
if not ("%q3ut4_path%")==("%CD%") (
set q3ut4_path=%CD%
) 
if not ("%1")==("configured") (
goto begin
) else (
goto start
)
REM ==============================================================================
REM ==============================================================================






:begin
color 0E
echo.
echo.
echo.
echo.
echo   ~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~~
echo  \\++++++++ +++                                            ___ _____ __ _ _ _
echo   \\++++ + + +             Mapmaker Batch Install            
echo    \\++++ + +                   version 02                         _____ __ _
echo     \\++ + +                                                       
echo     //++  +             Written by FSK405 wily duck             
echo    //+ + +                                                     _  __      ___
echo   //  +  +                         :V                       
echo  //+ +    +                                                       
echo   ~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~~
echo.
echo.
echo.
echo At any time you can hit control-c to stop the mapmaker script.
echo.
pause
cls





:start
REM ==============================================================================
REM ========================== START OF CONFIG ===================================
REM ==============================================================================


REM Welcome to the batch install file.



REM ------------------------
REM Defaults - change these!
REM ------------------------


REM You do not need to append a slash to the directory.

set q3ut4_path=C:\Program Files\ioUrbanTerror_1.0\q3ut4
REM ...........[path_to_q3ut4]



REM -----------------------------------------------------------------------------
REM If you have not used the mapmaker before, you'll want to get rid of the spare
REM files that were unzipped to q3ut4\maps. By default I will not do this for
REM safety reasons (i.e. .maps already existing that you do not want deleted).
REM If you have use version 01 or version 02 beta, I can delete the old files.
REM This process will be a little cleaner in the future.
REM -----------------------------------------------------------------------------



REM Set this to true if this is your first time you've run the mapmaker _AND_
REM you are ok with deleting all bsp's, aas's, and tga's in the maps/ directory.
REM If not, I leave it to you to do what you wish with the maps/ directory.

set clear_maps_dir=false
REM ...............[true|false]



REM Set this to true if you want .txt files in the maps/ directory also deleted.

set clear_maps_txt=false
REM ...............[true|false]



REM Set this to true, if you installed ut4_mapmaker version 01.

set clear_v01=false
REM ..........[true|false]



REM Set this to true, if you installed ut4_mapmaker version 02 beta [any].

set clear_v02_betas=false
REM ................[true|false]





REM -----------------------------------------------------------------------------


REM That's it!
REM You can now save and close this file. I will automatically re-run myself with
REM the new configuration. Thanks for using the mapmaker.





REM -----------------------------------------------------------------------------
REM                               Extras
REM -----------------------------------------------------------------------------


REM * Hint:
REM Where does ioUrbanTerror fit in this? Why do we keep talking about quake3
REM You don't even have quake3? If you don't, make sure you have your q3ut4
REM folder installed into the ioUrbanTerror folder. Then, instead of specifying
REM quake3/q3ut4 when asked, use ioUrbanTerror/q3ut4 instead where applicable.






REM ==============================================================================
REM ========================= End of config! =====================================
REM ========================= Save and exit! =====================================
REM ==============================================================================











REM ==============================================================================
REM
REM The script guts. Don't modify anything below here unless you really have to.
REM
REM ==============================================================================


if ("%1")==("configured") (
cmd /k "%q3ut4_path%\%install_mapmaker%" override
)

:config
echo %script_title%
echo ______________________________________________________________________________
echo !


REM We'll take proof of the current directory to skip some instructions.
if exist %current_zpak% (

color 0D
set q3ut4_path=%CD%

echo ! Aha, I see %current_zpak%, so we're definitely in the right place. Good start.
echo ! 
echo ______________________________________________________________________________
pause
goto edits

) else (
echo ! I don't see %current_zpak%, I expect that if I'm in the correct
echo ! q3ut4 directory, I'll see this file.
echo !

)


REM Give some more information if we're not sure.

echo ! Reviewing current config:
echo !   q3ut4_path = %q3ut4_path%
echo !   currentdir = %CD%
echo !

if /i ("%q3ut4_path%")==("%CD%") (
color 0F
echo !   Good, the current directory matches the q3ut4_path variable. We're in
echo !   the right place.
echo !
) else (
color 0C
echo !   The current directory does not match the q3ut4_path variable above! Most
echo !   likely you'll just have to set the q3ut4_path variable. It is important
echo !   that you have extracted the mapmaker files into your q3ut4 directory,
echo !   and are currently in the q3ut4 directory. We can continue and remedy 
echo !   this problem.
echo !

)


echo !
echo ______________________________________________________________________________
echo.
echo.
pause





REM ==============================================================================


:edits
cls

REM Don't need to do this a second time.
if ("%1")==("%CD%") goto ready

REM Startup text, first time through.
color 0B
echo ______________________________________________________________________________
echo !
echo ! Let's first make some quick edits to this batch file. I'll open notepad so
echo ! you can make the changes. Read the REM statements! They will help you
echo ! understand the install process.
echo !
echo ! Press a key to begin editing install_mapmaker_v02.bat
echo ______________________________________________________________________________
echo.
echo.
pause
cls
echo You are currently configuring %install_mapmaker% via notepad.
echo Waiting for you to save/close notepad with the config changes...
echo.
echo Currently in directory:
echo %CD%
echo.
echo The q3ut4_path variable currently contains:
echo %q3ut4_path%
echo.
echo   If I think you're in the correct directory already, I'll use your
echo   current directory as the q3ut4_path variable.
echo.

REM this opens notepad to edit this file
c:\windows\system32\notepad.exe %install_mapmaker%

echo.
cls

REM Ready to restart with configured options.
cls
color 0F
echo ______________________________________________________________________________
echo !
echo ! Reloading %install_mapmaker% with the updated config...
echo ______________________________________________________________________________
echo.
echo.
echo Batch files seem to have a problem with reloading when there's a space in
echo the path. If the script bombs when you press the button, run the command below
echo while making sure you're in your q3ut4 directory.
echo.
echo.%install_mapmaker% override
echo.
echo If you're not in the correct directory, we will restart from the beginning.
echo Be sure you have installed the mapmaker to the q3ut4 folder.
echo.
echo.
pause

cmd /k "%q3ut4_path%\%install_mapmaker%" configured

exit





:ready



color 0A
echo %script_title%
echo ______________________________________________________________________________
echo !
echo ! Seems like we're configured and ready. Let's start the batch installation.
echo ______________________________________________________________________________
echo.
echo.

echo clear_maps_dir = %clear_maps_dir%
echo clear_maps_txt = %clear_maps_txt%
echo clear_v01 = %clear_v01%
echo clear_v02_betas = %clear_v02_betas%
echo.
echo.

echo Now executing:
echo cmd /k %q3ut4_path%\%install_mapmaker%

echo.
echo.

echo If any of this is not correct, hit control-c now, say 'y' to terminate,
echo and re-run this script. Otherwise, thanks for using the mapmaker.

pause
cls




if (%clear_maps_dir%)==(true) (
color 0C
echo ______________________________________________________________________________
echo Cleaning up maps directory.
echo Last chance... I'm going to delete *.bsp, *.aas, and *.TGA from your maps/ dir.
echo Hit control-C to stop now if that's not cool!
echo ______________________________________________________________________________
echo.
pause
echo.
@echo on
del /F /Q maps\*.bsp
del /F /Q maps\*.aas
del /F /Q maps\*.TGA
@echo off
echo.
pause
echo.
)

if (%clear_maps_txt%)==(true) (
color 0C
echo Clearing .txt files.
echo.
pause
echo.
@echo on
del /F /Q maps\*.txt
@echo off
echo.
pause
echo.
)



REM Removal of ut_koth files from q3ut4, from mapmaker version 01

if (%clear_v01%)==(true) (
echo Deleting files from version 01.
echo.
pause
echo.
color 0C
@echo on
del /F /Q ut_koth.pk3
del /F /Q maps\ut_koth.map
del /F /Q maps\ut_koth.bsp
del /F /Q maps\ut_koth.TGA
del /F /Q maps\ut_koth.aas
del /F /Q scripts\ut_koth.arena
del /F /Q scripts\ut_koth.shader
del /F /Q levelshots\ut_koth.tga
rmdir /S /Q env\wilyduck
rmdir /S /Q textures\wilyduck_1
@echo off
echo.
pause
echo.
)



REM Removal of beta files that were moved or changed in v02

if (%clear_v02_betas%)==(true) (
echo Deleting files from version 02 betas.
echo.
pause
echo.
@echo on
del /F /Q install_mapmaker_v02.bat
del /F /Q README_ut4_mapmaker.html
del /F /Q radiant_gui_reference.html
del /F /Q "step 1 - INSTRUCTIONS.txt"
del /F /Q "step 2 - radiant_gui_reference.txt"
del /F /Q "step 3 - map_compiling.txt"
del /F /Q "step 4 - map_packaging.txt"
del /F /Q docs\"step 1 - INSTRUCTIONS.txt"
del /F /Q docs\"step 2 - radiant_gui_reference.txt"
del /F /Q docs\"step 3 - map_compiling.txt"
del /F /Q docs\"step 4 - map_packaging.txt"
@echo off
echo.
pause
echo.
)



REM End of cleanup









cls
color 0B
echo Press a key to install the gtk environment.
echo.
pause
color 0F
echo.
echo Waiting until the gtk runtime environment is installed.
files\gtk+-2.10.6-1-setup.exe
cls

color 0B
echo Press a key to install gtkRadiant-1.4.
echo.
pause
color 0F
echo.
echo Waiting until gtkRadiant install is completed.
echo.
echo If you have not installed Quake3 or RtCW, choose the default directories. If
echo you have installed ioUrbanTerror_1.0, be sure to change the Quake3 install path
echo to c:\program files\ioUrbanTerror_1.0 or wherever you installed Urban Terror.
echo.
echo You can uncheck the RtCW box in the custom setup if you'd like.
echo.
echo This might take a moment after the install is complete to continue.
files\GtkRadiantSetup-1.4.0-Q3RTCWET.exe
cls

color 0B
echo Next, edit the directory locations within local.pref.
echo Press a key to open local.pref in wordpad, you make the changes,
echo then save the file. Same ioUrbanTerror_1.0 rules apply, specify this directory
echo if that's where q3ut4 is located.
echo.
echo Be sure to use the correct slashes!
echo.
pause
color 0F
echo.
echo Waiting until local.pref has been edited and closed.
c:\windows\system32\write.exe "%q3ut4_path%\files\local.pref"
echo.
pause
cls

color 0F
echo I'll copy over your existing local.pref if you have one, but you can say no if
echo the file already exists. This will fail if you did not tell the gtkRadiant
echo setup the correct path to your Quake3 or ioUrbanTerror directory.
echo.
@echo on
copy files\local.pref "%q3ut4_path%\..\Radiant-1.4\"
@echo off
echo.
pause
cls

color 0B
echo Next, edit the directory locations within q3ut4_default.proj.
echo Press a key to open q3ut4_default.proj in wordpad, you make the changes,
echo then save the file.
echo.
pause
color 0F
echo.
echo Waiting until the the default project file has been edited and closed.
c:\windows\system32\write.exe "%q3ut4_path%\files\q3ut4_default.proj"
echo.
pause
cls

color 0F
echo I'll copy over your existing q3ut4_default.proj if you have one, but you can
echo say no if the file already exists.
echo.
@echo on
copy files\q3ut4_default.proj scripts\q3ut4_default.proj
@echo off
echo.
echo Press a key to continue once completed.
echo.
pause
cls

color 0B
echo Copying TwentySeven's q3map2 for Urban Terror 4 to:
echo C:\Program Files\GtkRadiant-1.4
echo.
echo Note: I will make a backup of your current q3map2. You can say no if you don't
echo want me to overwrite your existing q3map2.
echo.
@echo on
copy "C:\Program Files\GtkRadiant-1.4\q3map2.exe" "C:\Program Files\GtkRadiant-1.4\q3map2.exe.bak"
copy files\q3map2_fs_20g.exe "C:\Program Files\GtkRadiant-1.4\q3map2.exe"
@echo off
echo.
pause
cls

color 0F
echo Creating desktop shortcut.
echo.
@echo on
copy "files\ioUrT ut4_koth_dev.lnk" "%UserProfile%\Desktop\"
@echo off
echo.
pause
cls

color 0B
echo Opening the gtkRadiant command list located in docs\commandlist.rtf
echo You'll want to print it and keep this paper handy.
echo.
pause
color 0F
echo.
echo Waiting until the program is completed.
c:\windows\system32\write.exe docs/commandlist.rtf
echo.
pause
cls

color 0A
echo.
echo.
echo   ~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~~
echo.
echo That outta do it for the install. Press a key to load radiant. Happy mapping!
echo.
echo   ~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~^^~~
echo.
echo.
set install_mapmaker_completed=true
pause
cls


cmd /c "C:\Program Files\GtkRadiant-1.4\GtkRadiant-1.4.0.exe"


:end
color 07
echo _____________________________________________________________________________
echo.
echo %install_mapmaker% exiting. Thanks for playing.
echo _____________________________________________________________________________
echo.
echo.
exit
exit
exit